import { world, system } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe((initEvent) => {

    function applyEffects(player, effects) {
        effects.forEach(effect => {
            player.addEffect(effect.name, effect.duration, { amplifier: effect.amplifier, showParticles: effect.showParticles });
        });
    }

    initEvent.itemComponentRegistry.registerCustomComponent("notacola:on_consume", {
        onConsume: event => {
            const player = event.source;
            const itemStack = event.itemStack;
            if (itemStack.typeId === 'vb8:notacola') {
                applyEffects(player, [
                    { name: 'hunger', duration: 200, amplifier: 1, showParticles: true },
                    { name: 'strength', duration: 1200, amplifier: 0, showParticles: true }
                ]);
            }
        }
    });

    initEvent.itemComponentRegistry.registerCustomComponent("pipsi:on_consume", {
        onConsume: event => {
            const player = event.source;
            const itemStack = event.itemStack;
            if (itemStack.typeId === 'vb8:pipsi') {
                applyEffects(player, [
                    { name: 'hunger', duration: 200, amplifier: 0, showParticles: true },
                    { name: 'speed', duration: 1200, amplifier: 1, showParticles: true }
                ]);
            }
        }
    });

    initEvent.itemComponentRegistry.registerCustomComponent("premium_milk:on_consume", {
        onConsume: event => {
            const player = event.source;
            const itemStack = event.itemStack;
            if (itemStack.typeId === 'vb8:premium_milk') {
                applyEffects(player, [
                    { name: 'regeneration', duration: 60, amplifier: 4, showParticles: true },
                    { name: 'resistance', duration: 400, amplifier: 1, showParticles: true }
                ]);
            }
        }
    });

    initEvent.itemComponentRegistry.registerCustomComponent("premium_water:on_consume", {
        onConsume: event => {
            const player = event.source;
            const itemStack = event.itemStack;
            if (itemStack.typeId === 'vb8:premium_water') {
                applyEffects(player, [
                    { name: 'resistance', duration: 400, amplifier: 0, showParticles: true }
                ]);
            }
        }
    });

});
