import { world, system, GameMode, BlockPermutation } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
initEvent.itemComponentRegistry.registerCustomComponent("ak47:on_use", {
  onUse: event => {
    const player = event.source;
    const ItemStack = event.itemStack;
   const playerEquippable = player.getComponent("equippable");
    function damageDurability() {
  if (!player.matches({ gameMode: GameMode.creative })) {
    const itemDurability = ItemStack.getComponent("durability");
    if (!itemDurability) return;
    const itemMaxDurability = itemDurability.maxDurability;
    const itemDurabilityDamage = itemDurability.damage;
    const durabilityCalculation = itemMaxDurability - itemDurabilityDamage;
    const damageAmount = 1;
    const currentDurability = durabilityCalculation - damageAmount;
    if (currentDurability <= 0) {
      player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 vb8:ak47_empty 1 0');
    }
 else {
      itemDurability.damage += damageAmount;
      playerEquippable.setEquipment("Mainhand", ItemStack);
    }
  }
}
    if (ItemStack.typeId === "vb8:ak47") {
      const cooldown = ItemStack.getComponent("cooldown").getCooldownTicksRemaining(player);
      if (cooldown === 1) {
        const projectileEntity = player.dimension.spawnEntity("vb8:ak47_bullet", {
          x: player.location.x + player.getViewDirection().x,
          y: player.location.y + 2.0 + player.getViewDirection().y,
          z: player.location.z + player.getViewDirection().z
        });
        const projectileComponent = projectileEntity.getComponent("minecraft:projectile");
        const velocity = { x: player.getViewDirection().x, y: player.getViewDirection().y, z: player.getViewDirection().z };
        projectileComponent.owner = player;
        projectileComponent.shoot(velocity);
        player.playSound("ak47.shoot", { pitch: 0.9, location: player.location, volume: 0.7 });
       damageDurability();
      }
    }
  }
});
initEvent.itemComponentRegistry.registerCustomComponent("flamethrower:on_use", {
  onUse: event => {
    const player = event.source;
    const ItemStack = event.itemStack;
   const playerEquippable = player.getComponent("equippable");
    function damageDurability() {
  if (!player.matches({ gameMode: GameMode.creative })) {
    const itemDurability = ItemStack.getComponent("durability");
    if (!itemDurability) return;
    const itemMaxDurability = itemDurability.maxDurability;
    const itemDurabilityDamage = itemDurability.damage;
    const durabilityCalculation = itemMaxDurability - itemDurabilityDamage;
    const damageAmount = 1;
    const currentDurability = durabilityCalculation - damageAmount;
    if (currentDurability <= 0) {
      player.runCommand('replaceitem entity @s slot.weapon.mainhand 0 vb8:flamethrower_no_fuel 1 0');
    }
 else {
      itemDurability.damage += damageAmount;
      playerEquippable.setEquipment("Mainhand", ItemStack);
    }
  }
}
    if (ItemStack.typeId === "vb8:flamethrower") {
      const cooldown = ItemStack.getComponent("cooldown").getCooldownTicksRemaining(player);
      if (cooldown === 3) {
        const projectileEntity = player.dimension.spawnEntity("vb8:flamethrower_bullet", {
          x: player.location.x + player.getViewDirection().x,
          y: player.location.y + 2.0 + player.getViewDirection().y,
          z: player.location.z + player.getViewDirection().z
        });
        const projectileComponent = projectileEntity.getComponent("minecraft:projectile");
        const velocity = { x: player.getViewDirection().x, y: player.getViewDirection().y, z: player.getViewDirection().z };
        projectileComponent.owner = player;
        projectileComponent.shoot(velocity);
        player.playSound("flamethrower.shoot", { pitch: 0.9, location: player.location, volume: 0.7 });
       damageDurability();
      }
    }
  }
});
});