import { world } from "@minecraft/server";

world.afterEvents.worldInitialize.subscribe(() => {

    console.warn("World has been initialized");

    if (!world.getDynamicProperty("firstSpawnHandled")) {
        world.setDynamicProperty("firstSpawnHandled", false);
    }

    if (!world.getDynamicProperty("spawnX")) {
        world.setDynamicProperty("spawnX", 0);
    }

    if (!world.getDynamicProperty("spawnY")) {
        world.setDynamicProperty("spawnY", 0);
    }

    if (!world.getDynamicProperty("spawnZ")) {
        world.setDynamicProperty("spawnZ", 0);
    }

    world.afterEvents.playerSpawn.subscribe(async (eventData) => {

        const { initialSpawn, player } = eventData;

        const firstSpawnHandled = world.getDynamicProperty("firstSpawnHandled");

        if (!initialSpawn || firstSpawnHandled) return;

        const welcomeMessage = "§lWelcome to Crafton Hills!§r\n§2Structures are in the process of being created. Please explore and move around the environment so the world loads correctly. Thank you for downloading §eExperiment 8§2! We look forward to May you enjoy the Addon Created by §5Virtualblack8§2 and §fDodoFilms§2.";
        player.sendMessage(welcomeMessage);

        const { x, y, z } = player.location;
        world.setDynamicProperty("spawnX", x);
        world.setDynamicProperty("spawnY", y);
        world.setDynamicProperty("spawnZ", z);

        const structureY = y - 10;

        const structurePositions = {
            // Fila a
            'a1': [x - 320, structureY, z - 64], 
            'a2': [x - 320, structureY, z - 32], 
            'a3': [x - 320, structureY, z],
            'a4': [x - 320, structureY, z + 32], 
            'a5': [x - 320, structureY, z + 64], 
            'a6': [x - 320, structureY, z + 96],
            'a7': [x - 320, structureY, z + 128],  
            'a8': [x - 320, structureY, z + 160], 
            'a9': [x - 320, structureY, z + 192],
            'a10': [x - 320, structureY, z + 224], 
            'a11': [x - 320, structureY, z + 256], 
            'a12': [x - 320, structureY, z + 288],
            'a13': [x - 320, structureY, z + 320],
            'a14': [x - 320, structureY, z + 352], 
            'a15': [x - 320, structureY, z + 384],
            'a16': [x - 320, structureY, z + 416], 
            'a17': [x - 320, structureY, z + 448], 
            'a18': [x - 320, structureY, z + 480],
            'a19': [x - 320, structureY, z + 512],
            // Fila b
            'b1': [x - 288, structureY, z - 64], 
            'b2': [x - 288, structureY, z - 32], 
            'b3': [x - 288, structureY, z],
            'b4': [x - 288, structureY, z + 32], 
            'b5': [x - 288, structureY, z + 64], 
            'b6': [x - 288, structureY, z + 96],
            'b7': [x - 288, structureY, z + 128],  
            'b8': [x - 288, structureY, z + 160], 
            'b9': [x - 288, structureY, z + 192],
            'b10': [x - 288, structureY, z + 224], 
            'b11': [x - 288, structureY, z + 256], 
            'b12': [x - 288, structureY, z + 288],
            'b13': [x - 288, structureY, z + 320],
            'b14': [x - 288, structureY, z + 352], 
            'b15': [x - 288, structureY, z + 384],
            'b16': [x - 288, structureY, z + 416], 
            'b17': [x - 288, structureY, z + 448], 
            'b18': [x - 288, structureY, z + 480],
            'b19': [x - 288, structureY, z + 512],
            // Fila c
            'c1': [x - 256, structureY, z - 64], 
            'c2': [x - 256, structureY, z - 32], 
            'c3': [x - 256, structureY, z],
            'c4': [x - 256, structureY, z + 32], 
            'c5': [x - 256, structureY, z + 64], 
            'c6': [x - 256, structureY, z + 96],
            'c7': [x - 256, structureY, z + 128],  
            'c8': [x - 256, structureY, z + 160], 
            'c9': [x - 256, structureY, z + 192],
            'c10': [x - 256, structureY, z + 224], 
            'c11': [x - 256, structureY, z + 256], 
            'c12': [x - 256, structureY, z + 288],
            'c13': [x - 256, structureY, z + 320],
            'c14': [x - 256, structureY, z + 352], 
            'c15': [x - 256, structureY, z + 384],
            'c16': [x - 256, structureY, z + 416], 
            'c17': [x - 256, structureY, z + 448], 
            'c18': [x - 256, structureY, z + 480],
            'c19': [x - 256, structureY, z + 512],
            // Fila d
            'd1': [x - 224, structureY, z - 64], 
            'd2': [x - 224, structureY, z - 32], 
            'd3': [x - 224, structureY, z],
            'd4': [x - 224, structureY, z + 32], 
            'd5': [x - 224, structureY, z + 64], 
            'd6': [x - 224, structureY, z + 96],
            'd7': [x - 224, structureY, z + 128],  
            'd8': [x - 224, structureY, z + 160], 
            'd9': [x - 224, structureY, z + 192],
            'd10': [x - 224, structureY, z + 224], 
            'd11': [x - 224, structureY, z + 256], 
            'd12': [x - 224, structureY, z + 288],
            'd13': [x - 224, structureY, z + 320],
            'd14': [x - 224, structureY, z + 352], 
            'd15': [x - 224, structureY, z + 384],
            'd16': [x - 224, structureY, z + 416], 
            'd17': [x - 224, structureY, z + 448], 
            'd18': [x - 224, structureY, z + 480],
            'd19': [x - 224, structureY, z + 512],
            // Fila e
            'e1': [x - 192, structureY, z - 64], 
            'e2': [x - 192, structureY, z - 32], 
            'e3': [x - 192, structureY, z],
            'e4': [x - 192, structureY, z + 32], 
            'e5': [x - 192, structureY, z + 64], 
            'e6': [x - 192, structureY, z + 96],
            'e7': [x - 192, structureY, z + 128],  
            'e8': [x - 192, structureY, z + 160], 
            'e9': [x - 192, structureY, z + 192],
            'e10': [x - 192, structureY, z + 224], 
            'e11': [x - 192, structureY, z + 256], 
            'e12': [x - 192, structureY, z + 288],
            'e13': [x - 192, structureY, z + 320],
            'e14': [x - 192, structureY, z + 352], 
            'e15': [x - 192, structureY, z + 384],
            'e16': [x - 192, structureY, z + 416], 
            'e17': [x - 192, structureY, z + 448], 
            'e18': [x - 192, structureY, z + 480],
            'e19': [x - 192, structureY, z + 512],
            // Fila f
            'f1': [x - 160, structureY, z - 64], 
            'f2': [x - 160, structureY, z - 32], 
            'f3': [x - 160, structureY, z],
            'f4': [x - 160, structureY, z + 32], 
            'f5': [x - 160, structureY, z + 64], 
            'f6': [x - 160, structureY, z + 96],
            'f7': [x - 160, structureY, z + 128],  
            'f8': [x - 160, structureY, z + 160], 
            'f9': [x - 160, structureY, z + 192],
            'f10': [x - 160, structureY, z + 224], 
            'f11': [x - 160, structureY, z + 256], 
            'f12': [x - 160, structureY, z + 288],
            'f13': [x - 160, structureY, z + 320],
            'f14': [x - 160, structureY, z + 352], 
            'f15': [x - 160, structureY, z + 384],
            'f16': [x - 160, structureY, z + 416], 
            'f17': [x - 160, structureY, z + 448], 
            'f18': [x - 160, structureY, z + 480],
            'f19': [x - 160, structureY, z + 512],
            // Fila g
            'g1': [x - 128, structureY, z - 64], 
            'g2': [x - 128, structureY, z - 32], 
            'g3': [x - 128, structureY, z],
            'g4': [x - 128, structureY, z + 32], 
            'g5': [x - 128, structureY, z + 64], 
            'g6': [x - 128, structureY, z + 96],
            'g7': [x - 128, structureY, z + 128],  
            'g8': [x - 128, structureY, z + 160], 
            'g9': [x - 128, structureY, z + 192],
            'g10': [x - 128, structureY, z + 224], 
            'g11': [x - 128, structureY, z + 256], 
            'g12': [x - 128, structureY, z + 288],
            'g13': [x - 128, structureY, z + 320],
            'g14': [x - 128, structureY, z + 352], 
            'g15': [x - 128, structureY, z + 384],
            'g16': [x - 128, structureY, z + 416], 
            'g17': [x - 128, structureY, z + 448], 
            'g18': [x - 128, structureY, z + 480],
            'g19': [x - 128, structureY, z + 512],
            // Fila h
            'h1': [x - 96, structureY, z - 64], 
            'h2': [x - 96, structureY, z - 32], 
            'h3': [x - 96, structureY, z],
            'h4': [x - 96, structureY, z + 32], 
            'h5': [x - 96, structureY, z + 64], 
            'h6': [x - 96, structureY, z + 96],
            'h7': [x - 96, structureY, z + 128],  
            'h8': [x - 96, structureY, z + 160], 
            'h9': [x - 96, structureY, z + 192],
            'h10': [x - 96, structureY, z + 224], 
            'h11': [x - 96, structureY, z + 256], 
            'h12': [x - 96, structureY, z + 288],
            'h13': [x - 96, structureY, z + 320],
            'h14': [x - 96, structureY, z + 352], 
            'h15': [x - 96, structureY, z + 384],
            'h16': [x - 96, structureY, z + 416], 
            'h17': [x - 96, structureY, z + 448], 
            'h18': [x - 96, structureY, z + 480],
            'h19': [x - 96, structureY, z + 512],
            // Fila i
            'i1': [x - 64, structureY, z - 64], 
            'i2': [x - 64, structureY, z - 32], 
            'i3': [x - 64, structureY, z],
            'i4': [x - 64, structureY, z + 32], 
            'i5': [x - 64, structureY, z + 64], 
            'i6': [x - 64, structureY, z + 96],
            'i7': [x - 64, structureY, z + 128],  
            'i8': [x - 64, structureY, z + 160], 
            'i9': [x - 64, structureY, z + 192],
            'i10': [x - 64, structureY, z + 224], 
            'i11': [x - 64, structureY, z + 256], 
            'i12': [x - 64, structureY, z + 288],
            'i13': [x - 64, structureY, z + 320],
            'i14': [x - 64, structureY, z + 352], 
            'i15': [x - 64, structureY, z + 384],
            'i16': [x - 64, structureY, z + 416], 
            'i17': [x - 64, structureY, z + 448], 
            'i18': [x - 64, structureY, z + 480],
            'i19': [x - 64, structureY, z + 512],
            // Fila j
            'j1': [x - 32, structureY, z - 64], 
            'j2': [x - 32, structureY, z - 32], 
            'j3': [x - 32, structureY, z],
            'j4': [x - 32, structureY, z + 32], 
            'j5': [x - 32, structureY, z + 64], 
            'j6': [x - 32, structureY, z + 96],
            'j7': [x - 32, structureY, z + 128],  
            'j8': [x - 32, structureY, z + 160], 
            'j9': [x - 32, structureY, z + 192],
            'j10': [x - 32, structureY, z + 224], 
            'j11': [x - 32, structureY, z + 256], 
            'j12': [x - 32, structureY, z + 288],
            'j13': [x - 32, structureY, z + 320],
            'j14': [x - 32, structureY, z + 352], 
            'j15': [x - 32, structureY, z + 384],
            'j16': [x - 32, structureY, z + 416], 
            'j17': [x - 32, structureY, z + 448], 
            'j18': [x - 32, structureY, z + 480],
            'j19': [x - 32, structureY, z + 512],
            // Fila k (Posición del jugador en k3)
            'k1': [x, structureY, z - 64], 
            'k2': [x, structureY, z - 32], 
            'k3': [x, structureY, z],
            'k4': [x, structureY, z + 32], 
            'k5': [x, structureY, z + 64], 
            'k6': [x, structureY, z + 96],
            'k7': [x, structureY, z + 128],  
            'k8': [x, structureY, z + 160], 
            'k9': [x, structureY, z + 192],
            'k10': [x, structureY, z + 224], 
            'k11': [x, structureY, z + 256], 
            'k12': [x, structureY, z + 288],
            'k13': [x, structureY, z + 320],
            'k14': [x, structureY, z + 352], 
            'k15': [x, structureY, z + 384],
            'k16': [x, structureY, z + 416], 
            'k17': [x, structureY, z + 448], 
            'k18': [x, structureY, z + 480],
            'k19': [x, structureY, z + 512],
            // Fila l
            'l1': [x + 32, structureY, z - 64], 
            'l2': [x + 32, structureY, z - 32], 
            'l3': [x + 32, structureY, z],
            'l4': [x + 32, structureY, z + 32], 
            'l5': [x + 32, structureY, z + 64], 
            'l6': [x + 32, structureY, z + 96],
            'l7': [x + 32, structureY, z + 128],  
            'l8': [x + 32, structureY, z + 160], 
            'l9': [x + 32, structureY, z + 192],
            'l10': [x + 32, structureY, z + 224], 
            'l11': [x + 32, structureY, z + 256], 
            'l12': [x + 32, structureY, z + 288],
            'l13': [x + 32, structureY, z + 320],
            'l14': [x + 32, structureY, z + 352], 
            'l15': [x + 32, structureY, z + 384],
            'l16': [x + 32, structureY, z + 416], 
            'l17': [x + 32, structureY, z + 448], 
            'l18': [x + 32, structureY, z + 480],
            'l19': [x + 32, structureY, z + 512],
            // Fila m
            'm1': [x + 64, structureY, z - 64], 
            'm2': [x + 64, structureY, z - 32], 
            'm3': [x + 64, structureY, z],
            'm4': [x + 64, structureY, z + 32], 
            'm5': [x + 64, structureY, z + 64], 
            'm6': [x + 64, structureY, z + 96],
            'm7': [x + 64, structureY, z + 128],  
            'm8': [x + 64, structureY, z + 160], 
            'm9': [x + 64, structureY, z + 192],
            'm10': [x + 64, structureY, z + 224], 
            'm11': [x + 64, structureY, z + 256], 
            'm12': [x + 64, structureY, z + 288],
            'm13': [x + 64, structureY, z + 320],
            'm14': [x + 64, structureY, z + 352], 
            'm15': [x + 64, structureY, z + 384],
            'm16': [x + 64, structureY, z + 416], 
            'm17': [x + 64, structureY, z + 448], 
            'm18': [x + 64, structureY, z + 480],
            'm19': [x + 64, structureY, z + 512],
            // Fila n
            'n1': [x + 96, structureY, z - 64], 
            'n2': [x + 96, structureY, z - 32], 
            'n3': [x + 96, structureY, z],
            'n4': [x + 96, structureY, z + 32], 
            'n5': [x + 96, structureY, z + 64], 
            'n6': [x + 96, structureY, z + 96],
            'n7': [x + 96, structureY, z + 128],  
            'n8a': [x + 96, structureY, z + 160], 
            'n9': [x + 96, structureY, z + 192],
            'n10': [x + 96, structureY, z + 224], 
            'n11': [x + 96, structureY, z + 256], 
            'n12': [x + 96, structureY, z + 288],
            'n13': [x + 96, structureY, z + 320],
            'n14': [x + 96, structureY, z + 352], 
            'n15': [x + 96, structureY, z + 384],
            'n16': [x + 96, structureY, z + 416], 
            'n17': [x + 96, structureY, z + 448], 
            'n18': [x + 96, structureY, z + 480],
            'n19': [x + 96, structureY, z + 512],
            // Fila o
            'o1': [x + 128, structureY, z - 64], 
            'o2': [x + 128, structureY, z - 32], 
            'o3': [x + 128, structureY, z],
            'o4': [x + 128, structureY, z + 32], 
            'o5': [x + 128, structureY, z + 64], 
            'o6': [x + 128, structureY, z + 96],
            'o7': [x + 128, structureY, z + 128],  
            'o8': [x + 128, structureY, z + 160], 
            'o9': [x + 128, structureY, z + 192],
            'o10': [x + 128, structureY, z + 224], 
            'o11': [x + 128, structureY, z + 256], 
            'o12': [x + 128, structureY, z + 288],
            'o13': [x + 128, structureY, z + 320],
            'o14': [x + 128, structureY, z + 352], 
            'o15': [x + 128, structureY, z + 384],
            'o16': [x + 128, structureY, z + 416], 
            'o17': [x + 128, structureY, z + 448], 
            'o18': [x + 128, structureY, z + 480],
            'o19': [x + 128, structureY, z + 512],
            // Fila p
            'p1': [x + 160, structureY, z - 64], 
            'p2': [x + 160, structureY, z - 32], 
            'p3': [x + 160, structureY, z],
            'p4': [x + 160, structureY, z + 32], 
            'p5': [x + 160, structureY, z + 64], 
            'p6': [x + 160, structureY, z + 96],
            'p7': [x + 160, structureY, z + 128],  
            'p8': [x + 160, structureY, z + 160], 
            'p9': [x + 160, structureY, z + 192],
            'p10': [x + 160, structureY, z + 224], 
            'p11': [x + 160, structureY, z + 256], 
            'p12': [x + 160, structureY, z + 288],
            'p13': [x + 160, structureY, z + 320],
            'p14': [x + 160, structureY, z + 352], 
            'p15': [x + 160, structureY, z + 384],
            'p16': [x + 160, structureY, z + 416], 
            'p17': [x + 160, structureY, z + 448], 
            'p18': [x + 160, structureY, z + 480],
            'p19': [x + 160, structureY, z + 512],
            // Fila q
            'q1': [x + 192, structureY, z - 64], 
            'q2': [x + 192, structureY, z - 32], 
            'q3': [x + 192, structureY, z],
            'q4': [x + 192, structureY, z + 32], 
            'q5': [x + 192, structureY, z + 64], 
            'q6': [x + 192, structureY, z + 96],
            'q7': [x + 192, structureY, z + 128],  
            'q8': [x + 192, structureY, z + 160], 
            'q9': [x + 192, structureY, z + 192],
            'q10': [x + 192, structureY, z + 224], 
            'q11': [x + 192, structureY, z + 256], 
            'q12': [x + 192, structureY, z + 288],
            'q13': [x + 192, structureY, z + 320],
            'q14': [x + 192, structureY, z + 352], 
            'q15': [x + 192, structureY, z + 384],
            'q16': [x + 192, structureY, z + 416], 
            'q17': [x + 192, structureY, z + 448], 
            'q18': [x + 192, structureY, z + 480],
            'q19': [x + 192, structureY, z + 512],
        };

        const variants = {
            'b8': ['b8a', 'b8b'],
            'c17': ['nha', 'nhb', 'nhc'],
            'k17': ['k17a', 'k17b'],
            'i9': ['i9a', 'i9b', 'i9c', 'i9d'],
            'k16': ['k16a', 'k16b'],
            'm9': ['nha', 'nhb', 'nhc']
        };

        try {
            for (let structureName in structurePositions) {
                let position = structurePositions[structureName];
                
                if (variants[structureName]) {
                    const variantList = variants[structureName];
                    const randomIndex = Math.floor(Math.random() * variantList.length);
                    structureName = variantList[randomIndex];
                }

                await world.getDimension("overworld").runCommandAsync(`structure load mystructure:${structureName} ${position[0]} ${position[1]} ${position[2]}`);
            }
        } catch (error) {
            console.error(`Error loading structures: ${error}`);
        }

        world.setDynamicProperty("firstSpawnHandled", true);
    });
});


